/*
 * The Apache Software License, Version 1.1
 *
 *
 * Copyright (c) 2002 The Apache Software Foundation.  All rights 
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:  
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "WSIF" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written 
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation and was
 * originally based on software copyright (c) 2001, 2002, International
 * Business Machines, Inc., http://www.apache.org.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 */

package org.apache.wsif.util.jms;

import javax.jms.Destination;
import javax.jms.Queue;
import javax.jms.QueueConnectionFactory;
import org.apache.wsif.WSIFException;

/**
 * Finds JMS objects by going directly to MQSeries.
 * @author Mark Whitlock <whitlock@apache.org>
 */
class WSIFJMSFinderForMq extends WSIFJMSFinder {
    
    private QueueConnectionFactory factory;
    private Destination initialDestination;
    private String style;

    WSIFJMSFinderForMq(String jmsVendorURL, String implSpecURL)
        throws WSIFException {
        throw new WSIFException("not yet implemented");

        /*    try {
              factory = new MQQueueConnectionFactory();
              factory.setQueueManager("");
        
              connection = factory.createQueueConnection();
              session = connection.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
        
              readQ  = session.createQueue(readQName );
              writeQ = session.createQueue(writeQName);
              connection.start();
        
              if (startType==COLDSTART) {
                System.out.println("Wiping messages off the queues");
                Message msg=null;
                try {
        	      if (receiver==null) receiver=session.createReceiver(readQ);
                  for (;;) {
                    msg=receiver.receive(100);
                    if (msg!=null) System.out.println("Removing an input message");
                    else break;
                  }
                } catch (Exception e) {}
        
                try {
        	      QueueReceiver tmpRec = session.createReceiver(writeQ);
                  for (;;) {
                    msg=tmpRec.receive(100);
                    if (msg!=null) System.out.println("Removing an output message");
                    else break;
                  }
                } catch (Exception e) {}
              }
              
            } catch( JMSException je ) {
              System.out.println("caught JMSException: " + je);
              Exception le = je.getLinkedException();
              if (le != null) System.out.println("linked exception: "+le);
        	
            } catch( Exception e ) {
              System.out.println("Caught exception: " + e );
            } */

    }

    public QueueConnectionFactory getFactory() {
        return factory;
    }
    
    public Destination getInitialDestination() {
        return initialDestination;
    }
    
    String getStyle() {
        return style;
    }

    Queue findQueue(String name) throws WSIFException {
        return null;
    }
}